#include <bits/stdc++.h>

using namespace std;

int n,q;

int pusic(vector<int>& a, vector<int>& a1, int& l)
{
    sort(a1.begin(),a1.end());
    int len=a1.size();
    vector<vector<int>> dp(len+1);
    for(auto& v : dp)
        v.resize(len+1);

    for(int i=0; i<=len; ++i)
        dp[i][0]=0;
    for(int j=0; j<=len; ++j)
        dp[0][j]=0;
    for(int i=1; i<=len; ++i)
        for(int j=1; j<=len; ++j)
            if(a[i-1+l-1]==a1[j-1])
                dp[i][j]=dp[i-1][j-1]+1;
            else
                dp[i][j]=max(dp[i-1][j],dp[i][j-1]);
    return dp[len][len];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin>>n;
    vector<int> a(n);
    for(int& num : a)
        cin>>num;
    cin>>q;
    while(q--)
    {
        int l,r;
        cin>>l>>r;
        if(l==r)
        {
            cout<<"DA"<<'\n';
            continue;
        }
        vector<int> a1(r-l+1);
        for(int i=l-1; i<r; i++)
            a1.push_back(a[i]);
        if(pusic(a,a1,l)==r-l)
            cout<<"DA"<<'\n';
        else
            cout<<"NE"<<'\n';
    }

    return 0;


}